var xmlHttpRequest;
var gRefreshRequest;
var gOldValue;

function doGetDelicious()
{
	xmlHttpRequest = new XMLHttpRequest();
	xmlHttpRequest.onreadystatechange = readResponse;
	var delBox = document.getElementById( "category" );
	gOldValue = delBox.value;
	var strValue = gOldValue;
	var useUser = getDelBoolPref( "showMine" );
	var linkDel;
	if( useUser )
	{
		linkDel = "http://del.icio.us/rss/" + getDelCharPref("username") + "/";
	}
	else
	{
		linkDel = "http://del.icio.us/rss/tag/";
	}
	linkDel += strValue.replace(/\s/g, "+");
	xmlHttpRequest.open( "GET", linkDel );
	var buttonGetDel = document.getElementById("doGetDelBtn");
	buttonGetDel.disabled = true;
	xmlHttpRequest.send(null);
}

function readResponse()
{
	if( xmlHttpRequest.readyState == 4 )
	{
		var delBox = document.getElementById( "category" );
		delBox.value = gOldValue;
		var content = xmlHttpRequest.responseXML;
		var items = content.getElementsByTagName( "item" );
		
		var browser = document.getElementById( "content" );

		var arrayList = new Array();
		if( items.length > 5 )
		{
			totalLinks = 5;
		}
		else
		{
			totalLinks = items.length;
		}
		for( i = 0; i < totalLinks; i++ )
		{
			var stuff = items[i].getElementsByTagName( "link" );
			addToUniqueArray( arrayList, stuff[0].firstChild.nodeValue );
		}

		for( z = 0; z < arrayList.length; z++ )
		{
			browser.addTab( arrayList[z] );
		}
		var buttonGetDel = document.getElementById("doGetDelBtn");
		buttonGetDel.disabled = false;
	}
	else
	{
		var delBox = document.getElementById( "category" );
		delBox.value = "Working...";
	}
}

function doPost()
{
	var currentURI = gBrowser.currentURI.spec;
	var user = getDelCharPref("username");
	var postURI = "http://del.icio.us/" + user + "?v=2&url=" + encodeURIComponent( currentURI );
	postURI += "&title=" + encodeURIComponent( gBrowser.contentTitle );
	var contentArea=document.getElementById("appcontent");
	contentArea.addEventListener("load",postingDeliciousLoad,true);	
	gBrowser.loadURI( postURI );
}

function postingDeliciousLoad(aEvent)
{
	var doc = aEvent.originalTarget;
	var delBox = document.getElementById("category");
	doc.documentElement.getElementsByTagName("input").namedItem("tags").value = delBox.value;
	var contentArea=document.getElementById("appcontent");
	contentArea.removeEventListener("load", postingDeliciousLoad, true );
}

function doPopular()
{
	var comDel = document.getElementById( "commonDel" );
	var delBox = document.getElementById( "category" );
	delBox.value = comDel.value;
	doGetDelicious();
}

function doDeliciousRefresh()
{
	var buttonRefresh = document.getElementById("refresh");
	buttonRefresh.disabled = true;
	gRefreshRequest = new XMLHttpRequest();
	gRefreshRequest.onreadystatechange = readRefreshResponse;
	var useUser = getDelBoolPref( "showMine" );
	var strGet = "http://del.icio.us/rss";
	if( useUser == true )
	{
		strGet += "/" + getDelCharPref("username") + "/";
	}
	gRefreshRequest.open( "GET", strGet );
	gRefreshRequest.send(null);
}

function doDeliciousOptions()
{
	//also set maximum return pages
	window.openDialog("chrome://huntandgather/content/optionsGetDelicious.xul","showmore",
                  "chrome" );
}

function optionsDone()
{
	var huntBox = opener.document.getElementById( "category" );

	if( getDelBoolPref("showMine") == true )
	{
		huntBox.setAttribute( "style", "-moz-appearance:none;background-color:lime;" );
	}
	else
	{
		huntBox.setAttribute( "style", "-moz-appearance:none;background-color:white;" );
	}

	return true;
}

function initToolbar()
{
	var huntBox = document.getElementById( "category" );
	var pop = document.getElementById( "commonDel" );

	if( getDelBoolPref("showMine") == true )
	{
		huntBox.setAttribute( "style", "-moz-appearance:none;background-color:lime;" );
		pop.setAttribute( "style", "-moz-appearance:none;background-color:lime;" );
	}
	else
	{
		huntBox.setAttribute( "style", "-moz-appearance:none;background-color:white;" );
	}
}

function addToUniqueArray( theArray, subThing )
{
	var found = false;
	if( theArray.length == 0 )
	{
		theArray[0] = subThing;
		return;
	}
	for( k = 0; k < theArray.length; k++ )
	{
		if( theArray[k] == subThing )
		{
			found = true;
			break;
		}
	}
	if( found != true )
	{
		theArray[theArray.length] = subThing;
	}
	
}

function readRefreshResponse()
{
	if( gRefreshRequest.readyState == 4 )
	{
		try {
		var content = gRefreshRequest.responseXML;
		var items = content.getElementsByTagNameNS( "http://www.w3.org/1999/02/22-rdf-syntax-ns#", "Bag" );
		var arrayList = new Array();

		var doWholeTag = getDelBoolPref("showPhrases");
		var catsToGet;
		for( i = 0; i < items.length; i++ )
		{
			var subItems = items[i].getElementsByTagNameNS( "http://www.w3.org/1999/02/22-rdf-syntax-ns#", "li" );
			if( doWholeTag == true )
			{
				var totalTag;
				for( j = 0; j < subItems.length; j++ )
				{
					var thing = subItems[j].getAttribute( "resource" );
					var subThing = thing.substring( thing.indexOf("tag") + 4 );
					if( j != 0 )
					{
						totalTag += " " + subThing;
					}
					else
					{
						totalTag = subThing;
					}
				}
				addToUniqueArray( arrayList, totalTag );
			}
			else
			{
				for( j = 0; j < subItems.length; j++ )
				{
					var thing = subItems[j].getAttribute( "resource" );
					var subThing = thing.substring( thing.indexOf("tag") + 4 );
					addToUniqueArray( arrayList, subThing );
				}
			}
		}
		var comDel = document.getElementById( "commonDel" );
		comDel.removeAllItems();
		arrayList.sort();
		for( i = 0; i < arrayList.length; i++ )
		{
			comDel.appendItem( arrayList[i], arrayList[i] );
		}
		var pop = comDel.menupopup;
		pop.setAttribute( "style", "max-height:300px" );
		var buttonRefresh = document.getElementById("refresh");
		buttonRefresh.disabled = false;
		}
		catch(e) { 
			var buttonRefresh = document.getElementById("refresh");
			buttonRefresh.disabled = false;
			alert( "Trouble getting values from del.icio.us" );
		}

	}

}

